/*
 * print.help.c
 *
 * 

  Copyright Philippe Preux, 2009

  This is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this source file.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif

#include <stdio.h>
/* for getopt() arguments */
#include <ctype.h>
#include <getopt.h>
#include <errno.h>

void print_help (struct option *option_ptr)
{
  fprintf (stderr, "%s: available options\n", program_invocation_short_name);
  for (; option_ptr-> name; option_ptr ++) {
    if (isalpha (option_ptr-> val))
      fprintf (stderr, "\t--%s|-%c", option_ptr-> name, option_ptr-> val);
    else fprintf (stderr, "\t--%s", option_ptr-> name);
    if (option_ptr-> has_arg == 1)
      fprintf (stderr, " <arg>");
    else if (option_ptr-> has_arg == 2)
      fprintf (stderr, " [<arg>]");
    fputc ('\n', stderr);
  }
  fprintf (stderr, "output:\n");
}
